﻿Type=Class
Version=1.96
@EndOfDesignText@
'Class module

' Class to manage input sliders (similar to Seekbar) that allows use of images
Sub Class_Globals

	Private PtrPos As Double
	Private BarBGOrient As Boolean			' True = Vertical False = Horizontal
	Private MaxVal,MaxMove As Int
	Private BarBG As Panel
	Private Ptr As Panel
	Private ISName As String
	Private CF As Object
	Private Version As String
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Sub Initialize(CalledFrom As Object, Name As String,Parent As Object,Left As Int,Top As Int,Width As Int,Height As Int) As Boolean

	Version = "1.01"
	

	ISName=Name		' Used in call back process to call subroutines if present
					' ISName&"_ValueChanged" or ISname&"_PosChanged" in the calling
					' Activity
					
	CF = CalledFrom	'Store activity name for use with call back subs
	
	'Initialize Panels
	BarBG.Initialize("BarBG")
	Ptr.Initialize("Ptr")
	
	'Set default colours for panels, allows testing without loading images
	BarBG.Color=Colors.Blue
	Ptr.Color=Colors.Yellow
	
	'Set orientation
	If Width >= Height Then BarBGOrient = False Else BarBGOrient = True
	
	'Add views as appropriate
	If Parent Is Activity Then
		Dim Act As Activity
		Act=Parent
		Act.AddView(BarBG,Left,Top,Width,Height)
	Else
		If Parent Is Panel Then
			Dim Target As Panel
			Target = Parent
			Target.AddView(BarBG,Left,Top,Width,Height)
		Else
			Log("Invalid Parent, Must be Activity or Panel")
			'Initialization failed
			Return False
		End If
	End If
	
	'Initialize ptr size based on Orientation
	If BarBGOrient Then
		BarBG.AddView(Ptr,0,0,BarBG.Width,20dip)
	Else
		BarBG.AddView(Ptr,0,0,20dip,BarBG.Height)
	End If
	
	'Default Initializations
	PtrPos = 0
	If BarBGOrient Then
		setmaxmovev
		MaxVal = MaxMove
	Else
		setmaxmoveh
		MaxVal = MaxMove
	End If
	
	MovePtr(0.5)
	
	'Initialization completed
	Return True
End Sub
'Set size of the Bar Background, -1 leaves parameter as is
Sub SetBarBGSize(Left As Int,Top As Int,Width As Int,Height As Int)
	If Left <> -1 Then BarBG.Left=Left
	If Top <> -1 Then BarBG.Top=Top
	If Width <> -1 Then 
		BarBG.Width=Width
		If BarBGOrient = False Then setmaxmoveh
	End If
	If Height <> -1 Then 
		BarBG.Height=Height
		If BarBGOrient Then setmaxmovev
	End If
End Sub
'Set size of the Pointer Background, -1 leaves parameter as is
Sub SetPtrSize(Left As Int,Top As Int,Width As Int,Height As Int)
	If Left <> -1 Then Ptr.Left=Left
	If Top <> -1 Then Ptr.Top=Top
	If Width <> -1 Then 
		Ptr.Width=Width
		If BarBGOrient = False Then setmaxmoveh
	End If
	If Height <> -1 Then 
		Ptr.Height=Height
		If BarBGOrient Then setmaxmovev
	End If
End Sub
'Set Bar background image as BitmapDrawable
Sub SetBackGroundImage(Image As Bitmap)
	BarBG.SetBackGroundImage(Image)
End Sub
'Set Pointer background Image as BitmapDrawable
Sub SetPointerImage(Image As Bitmap)
	Ptr.SetBackGroundImage(Image)
End Sub
'Set MaxVal Value
Sub SetMaxVal(sMaxVal As Int)
	MaxVal=sMaxVal
End Sub
'Set Current Position (0 - 1) 
Sub SetPos(sValue As Double)
	PtrPos=sValue
	MovePtr(sValue)
End Sub
'Set Current Value *** Set MaxVal first
Sub SetValue (sPos As Double)
	PtrPos=sPos/MaxVal
	MovePtr(PtrPos)
End Sub
Private Sub BarBG_touch (Action As Int, X As Float, Y As Float)
	If Action = 0 Then
		If BarBGOrient Then
			
			MovePtr(Min(Max(0,Y *(MaxMove/BarBG.Height)),MaxMove)/MaxMove)
		Else
			'BarBG is horizontal
			
			MovePtr(Min(Max(0,X *(MaxMove/BarBG.Width)),MaxMove)/MaxMove)
		End If
	End If
	If Action = 2 Then
		If BarBGOrient Then
			
			MovePtr(Min(Max(0,Y *(MaxMove/BarBG.Height)),MaxMove)/MaxMove)
		Else
			'BarBG is horizontal
			
			MovePtr(Min(Max(0,X *(MaxMove/BarBG.Width)),MaxMove)/MaxMove)
		End If
	End If
	
End Sub
Private Sub MovePtr(Pos As Double)
	PtrPos=Pos
	If BarBGOrient Then
		Ptr.Top = Pos*MaxMove
	Else
		Ptr.Left=Pos*MaxMove
	End If
	
	'Check for call back subs and call id available
	If SubExists(CF,ISName&"_ValueChanged") Then
			CallSub2(CF,ISName&"_ValueChanged",GetValue)
	End If
	
	If SubExists(CF,ISName&"_PosChanged") Then
			CallSub2(CF,ISName&"_PosChanged",PtrPos)
	End If
End Sub
'Get the calculated value from the InputSlider
Sub GetValue As Float
	Return PtrPos*MaxVal
End Sub
'Returns position as float range 0-1
Sub GetPos As Float
	Return PtrPos
End Sub
Private Sub setmaxmovev
	'Determine maximum move allowed
	MaxMove=BarBG.Height-Ptr.Height
End Sub
Private Sub setmaxmoveh
	'Determine maximum move allowed
	MaxMove=BarBG.Width-Ptr.Width
End Sub
Sub GetVersion As String
	Return Version
End Sub